VERSION 5.00
Begin VB.Form frm_main 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "IC slave detector for K8000"
   ClientHeight    =   4530
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7635
   Icon            =   "frm_main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4530
   ScaleWidth      =   7635
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmd_about 
      Cancel          =   -1  'True
      Caption         =   "&About"
      Height          =   375
      Left            =   2640
      TabIndex        =   9
      Top             =   4080
      Width           =   1095
   End
   Begin VB.CommandButton cmd_close 
      Caption         =   "&Close"
      Height          =   375
      Left            =   3840
      TabIndex        =   8
      Top             =   4080
      Width           =   1095
   End
   Begin VB.Frame Frame2 
      Caption         =   "Port Selection"
      Height          =   1455
      Left            =   0
      TabIndex        =   4
      Top             =   2520
      Width           =   5055
      Begin VB.OptionButton port 
         Caption         =   "Port 0"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   7
         Top             =   1080
         Width           =   735
      End
      Begin VB.OptionButton port 
         Caption         =   "LPT2"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   6
         Top             =   720
         Width           =   735
      End
      Begin VB.OptionButton port 
         Caption         =   "LPT1"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Value           =   -1  'True
         Width           =   735
      End
   End
   Begin VB.Frame Frame1 
      Height          =   2415
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   5055
      Begin VB.ListBox List1 
         Height          =   1230
         Left            =   120
         TabIndex        =   3
         Top             =   480
         Width           =   4815
      End
      Begin VB.CommandButton cmd_scan 
         Caption         =   "&Scan K8000 card"
         Height          =   375
         Left            =   120
         TabIndex        =   2
         Top             =   1800
         Width           =   4815
      End
      Begin VB.Label Label1 
         Caption         =   "List of found IC devices:"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   3735
      End
   End
End
Attribute VB_Name = "frm_main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  ' declare all variables!
  Option Explicit
  
  ' calls to the DriverLinx PortIO Driver
  Private Declare Function DlPortReadPortUshort Lib "dlportio.dll" _
    (ByVal port As Long) As Integer
  Private Declare Sub DlPortWritePortUshort Lib "dlportio.dll" _
    (ByVal port As Long, ByVal Value As Integer)
    
  
  ' usertype which contains address information
  Private Type cardnr
    address As Integer
    description As String
  End Type

  ' declaration of object variables
  Dim Statusport As Integer       ' read port
  Dim Controlport As Integer      ' write port
  Dim I2Cbusdelay As Integer      ' delay factor
  Dim codearray(100) As cardnr    ' array with data information
  Dim testarray(255) As Boolean   ' chip present table


  ' about box
  Private Sub cmd_about_Click()
    MsgBox "IC slave detector for Velleman K8000" & _
            vbCrLf & vbCrLf & vbCrLf & _
           "copyright (c) 2003  Vanderhaegen Bart", _
           vbOKOnly + vbInformation, "IC Slave Scanner"
  End Sub


  ' program end
  Private Sub cmd_close_Click()
    Unload Me
  End Sub


  ' initiate scan
  Private Sub cmd_scan_Click()
  
    Dim na%, i%
  
  
    ' STEP 1: Loop through the IO chips and determine
    '         if they are present in the circuit.
    '
    For na = 0 To 255
      If (na And 1) = 0 Then   ' only use READ addresses
        testarray(na) = False
        CheckSlave na
        For i% = 0 To I2Cbusdelay%
        Next
      End If
    Next na
  
    
    ' STEP 2: Clear the list, so a previous session can
    '         will be resetted
    List1.Clear


 
    ' STEP 3: Load the chip address data into the program
    '         memory so fast searches can be performed.
    Dim code As Integer
    Dim descr As String
    Dim aantal As Integer
    Close
    aantal = 0
    Open App.Path & "\code.dat" For Input As #1
    Do While Not EOF(1)
      Input #1, code, descr
      codearray(aantal).address = code
      codearray(aantal).description = descr
      aantal = aantal + 1
    Loop
    Close
    
    
    ' STEP 4: Add the found IC slaves to the listbox,
    '         together with their extra information
    Dim teller As Integer
    For na = 0 To 255
      If testarray(na) = True Then
        teller = 0
          Do While (codearray(teller).address <> na And _
          teller < aantal)
            teller = teller + 1
          Loop
     
          If teller >= aantal Then
            ' chipcode not found
            List1.AddItem "chipcode=" & Format(na, "000") & " function: unknown"

          Else
            ' chipcode found
            List1.AddItem "chipcode=" & Format(na, "000") & " function:" & codearray(teller).description
          End If
      End If
    Next na
  End Sub


  ' program main routine
  Private Sub Form_Load()
    SelectI2CprinterPort 1
    I2Cbusdelay% = 1000
  End Sub


  ' port selection
  Private Sub port_Click(Index As Integer)
    Select Case Index
    Case 0
      ' LPT1
      SelectI2CprinterPort 1
    Case 1
      ' LPT2
      SelectI2CprinterPort 2
    Case 2
      ' Port0
      SelectI2CprinterPort 0
    End Select
  End Sub


  ' IC slave detection routine
  Sub CheckSlave(address As Integer)

    I2Cstart            ' make IC start condition
    I2COutput (address) ' send address
  
    Dim i%
    DlPortWritePortUshort Controlport%, 12
    For i% = 0 To I2Cbusdelay%
    Next
    
      For i% = 0 To I2Cbusdelay%
      Next
      
'      For i% = 0 To I2Cbusdelay%
'      Next
'
'        For i% = 0 To I2Cbusdelay%
'      Next
'
'        For i% = 0 To I2Cbusdelay%
'      Next
'
'        For i% = 0 To I2Cbusdelay%
'      Next
'        For i% = 0 To I2Cbusdelay%
'      Next
'        For i% = 0 To I2Cbusdelay%
'      Next
'        For i% = 0 To I2Cbusdelay%
'      Next
  
    Dim a As Integer
    a = DlPortReadPortUshort(Statusport%) And 16
    If a <> 16 Then testarray(address) = True

    DlPortWritePortUshort Controlport%, 4
    For i% = 0 To I2Cbusdelay%
    Next
  
    DlPortWritePortUshort Controlport%, 12
    For i% = 0 To I2Cbusdelay%
    Next

    I2CStop             ' make IC stop condition
  End Sub


  ' convert Decimal number to binary number
  Function DecToBin$(Decnumber%)
    Dim Bin$
    Dim Faktor%, i%

    Bin$ = ""
    Faktor% = 128

    If Decnumber% <> 0 Then
      For i% = 1 To 8
        If Faktor% > Decnumber% Then
          Bin$ = Bin$ + "0"
        Else
          Bin$ = Bin$ + "1"
          Decnumber% = Decnumber% - Faktor%
        End If
        Faktor% = Faktor% \ 2
      Next
      DecToBin$ = Bin$
    Else
      DecToBin$ = "00000000"
    End If
  End Function


  ' printerport selection routine
  Sub SelectI2CprinterPort(PrinterNo%)
    Select Case PrinterNo
    Case 0
      Statusport% = 957
      Controlport% = 958
    Case 1
      Statusport% = 889
      Controlport% = 890
    Case 2
      Statusport% = 633
      Controlport% = 634
    End Select
  End Sub

  
  ' generate IC start condition
  Sub I2Cstart()
    Dim i%
    DlPortWritePortUshort Controlport%, 6
    For i% = 0 To I2Cbusdelay%
    Next

    DlPortWritePortUshort Controlport%, 14
    For i% = 0 To I2Cbusdelay%
    Next
  End Sub


  ' generate IC stop condition
  Sub I2CStop()
    Dim i%
    DlPortWritePortUshort Controlport%, 14
    For i% = 0 To I2Cbusdelay%
    Next

    DlPortWritePortUshort Controlport%, 6
    For i% = 0 To I2Cbusdelay%
    Next

    DlPortWritePortUshort Controlport%, 4
    For i% = 0 To I2Cbusdelay%
    Next
  End Sub


  ' routine to send output to IC bus
  Sub I2COutput(Serdata%)
    Dim Temp%
    Dim Serdat$
    Dim j%
    Dim DataOut%
    Dim i%
    Temp% = Serdata%
    Serdat$ = DecToBin(Temp%)

    For j% = 1 To 8
      If Mid$(Serdat$, j%, 1) = "1" Then
        DataOut% = 12
      Else
        DataOut% = 14
      End If
      DlPortWritePortUshort Controlport%, DataOut%
      For i% = 0 To I2Cbusdelay%
      Next

      DataOut% = DlPortReadPortUshort(Controlport%) And 7
      DlPortWritePortUshort Controlport%, DataOut%
      For i% = 0 To I2Cbusdelay%
      Next

      DataOut% = DlPortReadPortUshort(Controlport%) Or 8
      DlPortWritePortUshort Controlport%, DataOut%
      For i% = 0 To I2Cbusdelay%
      Next
    Next
End Sub


